setTimeout(() => {
    const UnitActions = Controls.getDefinition('unit-actions').createInstance;

    const setupUnitInfoBase = UnitActions.prototype.setupUnitInfo;
    UnitActions.prototype.setupUnitInfo = function() {
        setupUnitInfoBase.call(this);

        if (!("UnitPortraitVisualRemaps" in window)) {
            return;
        }

        if (!this.unitId) {
            return;
        }

        const unit = Units.get(this.unitId);
        if(!unit) {
            return;
        }

        const unitDef = GameInfo.Units.lookup(unit.type);
        if (!unitDef) {
            console.error(`No unit definition found for ${unit.name}`);
            return;
        }

        const unitType = unitDef.UnitType;
        if(!(unitType in window.UnitPortraitVisualRemaps)) {
            console.error(`No unit portrait replace found for ${unitType}`);
            return;
        }

        const config = window.UnitPortraitVisualRemaps[unitType];
        WorldUI.requestPortrait(config.unitType, config.unitType, config.background);
        this.portraitImage.style.backgroundImage = `url("live:/${config.unitType}")`;
    }
}, 100);

setTimeout(() => {
    const ArmyPanel = Controls.getDefinition('army-panel').createInstance;
    const createArmyUnitButtonBase = ArmyPanel.prototype.createArmyUnitButton;
    ArmyPanel.prototype.createArmyUnitButton = function(unitId) {
        const newUnitButton =  createArmyUnitButtonBase.call(this, unitId);

        if (!("UnitPortraitVisualRemaps" in window)) {
            return newUnitButton;
        }

        const unit = Units.get(unitId);
        if(!unit) {
            return newUnitButton;
        }

        const unitDef = GameInfo.Units.lookup(unit.type);
        if (!unitDef) {
            console.error(`No army definition found for ${unit.name}`);
            return newUnitButton;
        }

        const unitType = unitDef.UnitType;
        if(!(unitType in window.UnitPortraitVisualRemaps)) {
            console.error(`No army portrait replace found for ${unitType}`);
            return newUnitButton;
        }

        const portraitImage = newUnitButton.querySelector('.army-panel__unit-portrait-image');
        if(!portraitImage) {
            console.error(`No army portrait element found for ${unitType}`);
            return newUnitButton;
        }

        const config = window.UnitPortraitVisualRemaps[unitType];
        WorldUI.requestPortrait(config.unitType, config.unitType, config.background);
        portraitImage.style.backgroundImage = `url("live:/${config.unitType}")`;

        return newUnitButton;
    }
}, 100);
